<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Neo4J.Conversion.Utils</span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Neo4J.Conversion.Utils.html#conversionError"><span class="hs-identifier">conversionError</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Utils.html#getNumber"><span class="hs-identifier">getNumber</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Neo4J.Conversion.Utils.html#getRoot"><span class="hs-identifier">getRoot</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Map</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">M</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Text</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">T</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Database.Bolt</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="EuskeraAppError.html"><span class="hs-identifier">EuskeraAppError</span></a></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.Nominal.html"><span class="hs-identifier">Features.Nominal</span></a></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="annot"><a href="Neo4J.Conversion.Utils.html#conversionError"><span class="hs-identifier hs-type">conversionError</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Node</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span>
</span><span id="line-11"></span><span id="conversionError"><span class="annot"><span class="annottext">conversionError :: Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.Utils.html#conversionError"><span class="hs-identifier hs-var hs-var">conversionError</span></a></span></span><span> </span><span id="local-6989586621679082296"><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082296"><span class="hs-identifier hs-var">node</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-12"></span><span>  </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError Lexis
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">(EuskeraAppError -&gt; Either EuskeraAppError Lexis)
-&gt; EuskeraAppError -&gt; Either EuskeraAppError Lexis
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; EuskeraAppError
</span><a href="EuskeraAppError.html#ConversionError"><span class="hs-identifier hs-var">ConversionError</span></a></span><span> </span><span class="annot"><span class="annottext">(String -&gt; EuskeraAppError) -&gt; String -&gt; EuskeraAppError
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Node id: &quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; String -&gt; String
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">Int -&gt; String
forall a. Show a =&gt; a -&gt; String
</span><span class="hs-identifier hs-var">show</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Node -&gt; Int
</span><span class="hs-identifier hs-var hs-var">nodeIdentity</span></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082296"><span class="hs-identifier hs-var">node</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="hs-comment">-- | Retrieves root property from node</span><span>
</span><span id="line-15"></span><span class="annot"><a href="Neo4J.Conversion.Utils.html#getRoot"><span class="hs-identifier hs-type">getRoot</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Node</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-16"></span><span id="getRoot"><span class="annot"><span class="annottext">getRoot :: Node -&gt; String
</span><a href="Neo4J.Conversion.Utils.html#getRoot"><span class="hs-identifier hs-var hs-var">getRoot</span></a></span></span><span> </span><span id="local-6989586621679082292"><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082292"><span class="hs-identifier hs-var">node</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Text -&gt; Map Text Value -&gt; Maybe Value
forall k a. Ord k =&gt; k -&gt; Map k a -&gt; Maybe a
</span><span class="hs-identifier hs-var">M.lookup</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082290"><span class="hs-identifier hs-var">root</span></a></span><span> </span><span class="annot"><span class="annottext">Map Text Value
</span><a href="#local-6989586621679082289"><span class="hs-identifier hs-var">properties</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-17"></span><span>  </span><span class="annot"><span class="annottext">Maybe Value
</span><span class="hs-identifier hs-var">Nothing</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-18"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">T</span></span><span> </span><span id="local-6989586621679082287"><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082287"><span class="hs-identifier hs-var">x</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Text -&gt; String
</span><span class="hs-identifier hs-var">T.unpack</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082287"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-19"></span><span>  </span><span class="annot"><span class="annottext">Maybe Value
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;&quot;</span></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-21"></span><span>    </span><span id="local-6989586621679082289"><span class="annot"><span class="annottext">properties :: Map Text Value
</span><a href="#local-6989586621679082289"><span class="hs-identifier hs-var hs-var">properties</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Map Text Value
</span><span class="hs-identifier hs-var hs-var">nodeProps</span></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082292"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-22"></span><span>    </span><span id="local-6989586621679082290"><span class="annot"><span class="annottext">root :: Text
</span><a href="#local-6989586621679082290"><span class="hs-identifier hs-var hs-var">root</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;root&quot;</span></span><span>
</span><span id="line-23"></span><span>
</span><span id="line-24"></span><span class="hs-comment">-- | Retrieves number from Node</span><span>
</span><span id="line-25"></span><span class="hs-comment">-- If number property is  missing from Node,</span><span>
</span><span id="line-26"></span><span class="hs-comment">-- Singular is assigned by default</span><span>
</span><span id="line-27"></span><span class="annot"><a href="Neo4J.Conversion.Utils.html#getNumber"><span class="hs-identifier hs-type">getNumber</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Node</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span>
</span><span id="line-28"></span><span id="getNumber"><span class="annot"><span class="annottext">getNumber :: Node -&gt; Number
</span><a href="Neo4J.Conversion.Utils.html#getNumber"><span class="hs-identifier hs-var hs-var">getNumber</span></a></span></span><span> </span><span id="local-6989586621679082283"><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082283"><span class="hs-identifier hs-var">node</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Text -&gt; Map Text Value -&gt; Maybe Value
forall k a. Ord k =&gt; k -&gt; Map k a -&gt; Maybe a
</span><span class="hs-identifier hs-var">M.lookup</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082282"><span class="hs-identifier hs-var">number</span></a></span><span> </span><span class="annot"><span class="annottext">Map Text Value
</span><a href="#local-6989586621679082281"><span class="hs-identifier hs-var">properties</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-30"></span><span>    </span><span class="annot"><span class="annottext">Maybe Value
</span><span class="hs-identifier hs-var">Nothing</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span> </span><span class="hs-comment">--</span><span>
</span><span id="line-31"></span><span>    </span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">T</span></span><span> </span><span id="local-6989586621679082279"><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082279"><span class="hs-identifier hs-var">x</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-32"></span><span>      </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Text -&gt; String
</span><span class="hs-identifier hs-var">T.unpack</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><a href="#local-6989586621679082279"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-33"></span><span>        </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Singular&quot;</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span>
</span><span id="line-34"></span><span>        </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Plural&quot;</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Plural"><span class="hs-identifier hs-var">Plural</span></a></span><span>
</span><span id="line-35"></span><span>        </span><span class="annot"><span class="annottext">String
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span>
</span><span id="line-36"></span><span>    </span><span class="annot"><span class="annottext">Maybe Value
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Number
</span><a href="Features.Nominal.html#Singular"><span class="hs-identifier hs-var">Singular</span></a></span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-38"></span><span>    </span><span id="local-6989586621679082281"><span class="annot"><span class="annottext">properties :: Map Text Value
</span><a href="#local-6989586621679082281"><span class="hs-identifier hs-var hs-var">properties</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Node -&gt; Map Text Value
</span><span class="hs-identifier hs-var hs-var">nodeProps</span></span><span> </span><span class="annot"><span class="annottext">Node
</span><a href="#local-6989586621679082283"><span class="hs-identifier hs-var">node</span></a></span><span>
</span><span id="line-39"></span><span>    </span><span id="local-6989586621679082282"><span class="annot"><span class="annottext">number :: Text
</span><a href="#local-6989586621679082282"><span class="hs-identifier hs-var hs-var">number</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;defaultNumber&quot;</span></span><span>
</span><span id="line-40"></span></pre></body></html>